<?php

namespace SAE\attachment;

function upload_dir($uploads){
	//Modify where attachments should upload and where users should access to
	$uploads['basedir'] = SAE_TMP_DIR_STORAGE;
	$uploads['baseurl'] = SAE_URL;
	$uploads['path'] = SAE_TMP_DIR_STORAGE.$uploads['subdir'];
	$uploads['url'] = SAE_URL.$uploads['subdir'];
	
	return $uploads;
}

function handle_upload($file){
	$s = new \SaeStorage();
	
	//Set unique filename
	$filename = \basename($file['file']);
	$dirname = \dirname($file['file']);
	$new_loc = $dirname.'/'.unique_filename(SAE_UPLOAD_DIR.\str_replace(SAE_TMP_DIR_STORAGE.'/', '/', $dirname), $filename);
	\rename($file['file'], $new_loc);
	$file['file'] = $new_loc;
	
	$filename = \str_replace(SAE_TMP_DIR_STORAGE.'/', '', $file['file']);
	
	//Upload Attachment
	$s->upload(SAE_STORAGE, SAE_UPLOAD_DIR.'/'.$filename, $file['file']);
	
	return $file;
}

function upload_all($file = null, $aid = null){
	upload_directory(SAE_TMP_DIR_STORAGE);
	
	return $file;
}

function upload_directory($directory){
	if(substr($directory, -1, 1) === '/')
		$directory = substr($directory, 0, strlen($directory)-1);
		
	if($handle = opendir($directory)){
		while(false !== ($file = readdir($handle))){
			if($file !== '.' && $file !== '..'){
				if(is_dir($directory.'/'.$file)){
					upload_directory($directory.'/'.$file);
				}else{
					upload_file($directory.'/'.$file);
				}
			}
		}
	}
}

function upload_file($file, $clean = true){
	$s = new \SaeStorage();
	
	$filename = \str_replace(SAE_TMP_DIR_STORAGE.'/', '', $file);
	
	//Upload Attachment
	$s->upload(SAE_STORAGE, SAE_UPLOAD_DIR.'/'.$filename, $file);
	
}

function upload_thumb($metadata){
	//All types of file will trigger this filter
	//But only images could have contents in array $metadata
	if(isset($metadata['sizes'])){
		$dir = SAE_TMP_DIR_STORAGE.'/'.dirname($metadata['file']);
		$s = new \SaeStorage();
		foreach($metadata['sizes'] as $size_name => $image_meta){
			$file = $image_meta['file'];
			$s->upload(SAE_STORAGE, SAE_UPLOAD_DIR.'/'.dirname($metadata['file']).'/'.$image_meta['file'], $dir.'/'.$image_meta['file']);
		}
	}
	return $metadata;
}

function delete_file($file){
	$url_pos = \strpos($file, '/storage/');
	if($url_pos !== false){
		$file = \substr($file, $url_pos + 9);
	}
	$file = SAE_UPLOAD_DIR.'/'.$file;
	
	$s = new \SaeStorage();
	$result = $s->delete(SAE_STORAGE, $file);
	return $file;
}

function unique_filename( $dir, $filename ) {
	// sanitize the file name before we begin processing
	$filename = \sanitize_file_name($filename);

	// separate the filename into a name and extension
	$info = \pathinfo($filename);
	$ext = !empty($info['extension']) ? '.' . $info['extension'] : '';
	$name = \basename($filename, $ext);

	// edge case: if file is named '.ext', treat as an empty name
	if ( $name === $ext )
		$name = '';

	$number = '';

	// change '.ext' to lower case
	if ( $ext && \strtolower($ext) != $ext ) {
		$ext2 = \strtolower($ext);
		$filename2 = \preg_replace( '|' . \preg_quote($ext) . '$|', $ext2, $filename );

		// check for both lower and upper case extension or image sub-sizes may be overwritten
		while ( file_exists($dir . "/$filename") || file_exists($dir . "/$filename2") ) {
			$new_number = $number + 1;
			$filename = \str_replace( "$number$ext", "$new_number$ext", $filename );
			$filename2 = \str_replace( "$number$ext2", "$new_number$ext2", $filename2 );
			$number = $new_number;
		}
		return $filename2;
	}

	while ( file_exists( $dir . "/$filename" ) ) {
		if ( '' == "$number$ext" )
			$filename = $filename . ++$number . $ext;
		else
			$filename = \str_replace( "$number$ext", ++$number . $ext, $filename );
	}

	return $filename;
}

function file_exists($filename){
	$s = new \SaeStorage();
	return $s->fileExists(SAE_STORAGE, $filename);
}

?>