<?php
/*
Plugin Name: ChloroAttachment for WordPress
Plugin URI: http://martincl2.me/archives/453
Description: SAE Storage 附件上传，代替原版WordPress的附件上传功能以兼容SAE环境
Version: 1.1
Author: Martin Chloride
Author URI: http://martincl2.me
*/

/*  Copyright 2013  Martin Chloride  (email : i@martincl2.me)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

namespace SAE\attachment;

include('chloroattachment.menu.php');
include('chloroattachment.core.php');

\register_activation_hook( __FILE__, 'SAE\attachment\install'); 
\add_action('init', 'SAE\attachment\init');
\add_action('admin_menu', 'SAE\attachment\menu');
\add_filter('plugin_action_links', 'SAE\attachment\link',9999,2);

function init(){
	$action = \basename($_SERVER['SCRIPT_FILENAME']);
	switch ($action)
	{
		case 'update.php':
		case 'update-core.php':
		case 'install.php':
			break;
			
		default:
			$storage_domain = \get_option('storage_domain');
			$storage_directory = \get_option('storage_directory');
			
			if($storage_domain === false){
				\add_option('storage_domain', 'wordpress');
				$storage_domain = 'wordpress';
			}
			
			if($storage_directory === false)
			{
			 	\add_option('storage_directory', 'uploads');
			 	$storage_directory = 'uploads';
			}
			
			define('SAE_STORAGE', $storage_domain);
			define('SAE_UPLOAD_DIR', $storage_directory);
			
			define('SAE_DIR', 'saestor://'.SAE_STORAGE);
			define('SAE_URL', 'http://'.$_SERVER['HTTP_APPNAME'].'-'.SAE_STORAGE.'.stor.sinaapp.com/'.SAE_UPLOAD_DIR);
			define('SAE_TMP_DIR_STORAGE', \SAE_TMP_PATH.'storage');
			
			\add_filter('upload_dir', 'SAE\attachment\upload_dir');
			\add_filter('wp_handle_upload', 'SAE\attachment\handle_upload');
			\add_filter('wp_create_file_in_uploads', 'SAE\attachment\upload_all');
			\add_filter('wp_generate_attachment_metadata', 'SAE\attachment\upload_thumb', 999);
			\add_filter('wp_delete_file', 'SAE\attachment\delete_file');
			break;
	}
	
	return;
}

function menu(){
	add_options_page('SAE Storage 参数配置', 'SAE Storage 附件上传', 'administrator', 'config-chloroattachment', 'SAE\attachment\config_menu');
	
	return;
}

function install(){
	if(!\get_option('storage_domain')){
		\add_option('storage_domain', 'wordpress');
	}
	if(!\get_option('storage_directory')){
		\add_option('storage_directory', 'uploads');
	}
}

function link($links, $file) {
	if ($file == 'sae-attachment/chloroattachment.php' && function_exists("admin_url")) {
		$settings_link[] = '<a href="' . admin_url('options-general.php?page=config-chloroattachment' ). '">' . __('Settings') . '</a>';
		$links = array_merge($settings_link, $links);
	}
	return $links;
}

?>